

class AsyncTask:
    BASE_URI = '../dde/{}/'
    TASK_URI = BASE_URI + 'api/asynctasks/{}'

    def __init__(self, api, dde, url, **kwargs):
        self.api = api
        self.dde = dde
        self.last_id = 0
        self.last_file_id = 0
        uri = self.BASE_URI + url
        self._finished = False
        post = api.post(uri.format(dde), data={key: value for key, value in kwargs.items() if value is not None})
        self.task_id = post.get('task_id')

    def __enter__(self):
        return self

    def __exit__(self, exc_type, exc_val, exc_tb):  # @UnusedVariable
        pass

    def get_lines(self):
        result_url = self.TASK_URI + "/progress_results?sort=id&page_size=1000&page=1&id=gt:{}"
        res = self.api.get(result_url.format(self.dde, self.task_id, self.last_id))
        if res:
            self.last_id = res[-1].get('id')
        return res

    def get_files(self):
        result_url = self.TASK_URI + "/file_results?sort=id&page_size=1000&page=1&id=gt:{}"
        res = self.api.get(result_url.format(self.dde, self.task_id, self.last_file_id))
        if res:
            self.last_file_id = res[-1].get('id')
        return res

    def is_task_finished(self):
        if not self._finished:
            task_url = self.TASK_URI.format(self.dde, self.task_id)
            result = self.api.get(task_url)
            status = result.get('status')
            self._finished = (status != 'RUNNING')
        return self._finished
