# Flake8: noqa
from importlib import import_module
from infinishell.infishell import manifest

__all__ = ["manifest"]

COMMAND_MODULES = """

    general
    magic

    system
    pool
    volume
    host
    cluster
    mapping
    filesystem
    filesystem_export
    consgroup
    replication
    mobility
    qos

    node
    bbu
    enclosure
    drive

    events
    user
    metadata

    config
    config.general
    config.notifications
    config.ldap
    config.system
    config.fc
    config.network

    metrics

    support

    smb

    infiniguard.general
    infiniguard.task
    infiniguard.nodes
    infiniguard.ports
    infiniguard.infinisafe
    infiniguard.snapshot
    infiniguard.policy
    infiniguard.replication
    infiniguard.nettools
    infiniguard.appspecific
    infiniguard.route
    infiniguard.interface
    infiniguard.ethernet_ports
    infiniguard.system
    infiniguard.share
    infiniguard.useraccess
    infiniguard.hostaccess
    infiniguard.compareclamation
    infiniguard.cifs

    vvol

"""


def import_commands():
    this_package_name = __name__[:__name__.rfind('.')]
    for commands_module in COMMAND_MODULES.split():
        import_module(this_package_name + ".commands." + commands_module)


import_commands()
del import_commands
